/*
 * lts.h
 *
 *  Created on: 28 мая. 2022 г.
 *      Author: vladimir
 */

#ifndef LTS_H_
#define LTS_H_

#include <stdint.h>

typedef enum {
	LTS_STATE_IDLE = 0,
	LTS_STATE_AUTO = 1,
	LTS_STATE_MAINTANCE = 2,
	LTS_STATE_ERROR = 3,
	LTS_STATE_MAX = 4,
} LtsState;

typedef enum {
	LTS_IOPOINT_LTS_STATE_IDLE = 0,
	LTS_IOPOINT_LTS_STATE_AUTO = 1,
	LTS_IOPOINT_LTS_STATE_MAINTANCE = 2,
	LTS_IOPOINT_LTS_STATE_MAINTANCE_ALLOW_FOCUS = 3,
	LTS_IOPOINT_LTS_STATE_MAINTANCE_FOCUSED = 4,
	LTS_IOPOINT_LTS_STATE_ERROR = 5,
	LTS_IOPOINT_LTS_STATE_EXT_ERROR = 6,
	LTS_IOPOINT_LTS_STATE_MAX = 7,
} LtsIOPointLtsState;


typedef enum {
	LTS_ERROR_OFFLINE = 0,
	LTS_ERROR_FCONVERTER_OFFLINE = 1,
	LTS_ERROR_BW_JAM = 2,
	LTS_ERROR_FW_JAM = 3,
	LTS_ERROR_UPPER_JAM = 4,
	LTS_ERROR_MAX = 5,
} LtsError;


typedef enum {
	LTS_PROFILE_TRANSIT_FULL = 0,
	LTS_PROFILE_TRANSIT_HALF = 1,
	LTS_PROFILE_CAROUSEL = 2,
	LTS_PROFILE_MAX = 3,
} LtsProfile;

typedef enum {
	LTS_DRIVE_STATE_STOP = 0,
	LTS_DRIVE_STATE_BW = 1,
	LTS_DRIVE_STATE_FW = 2,
	LTS_DRIVE_STATE_MAX = 3,
} LtsDriveState;

extern const char* const lts_state_names[LTS_STATE_MAX];
extern const char* const lts_iopoint_lts_state_names[LTS_IOPOINT_LTS_STATE_MAX];
extern const char* const lts_error_names[LTS_ERROR_MAX];
extern const char* const lts_profile_names[LTS_PROFILE_MAX];
extern const char* const lts_drive_state_names[LTS_DRIVE_STATE_MAX];

#pragma pack(push)
#pragma pack(1)


typedef union {
	struct {
		uint8_t drive_state : 2;
		uint8_t bw_sensor_state : 1;
		uint8_t fw_sensor_state : 1;
		uint8_t accept_ready : 1;
		uint8_t luggage_present : 1;
	};
	uint16_t data;
} LtsIOPointLtsOperateStatus;

#pragma pack(pop)


#endif /* LTS_H_ */
